| Flutter Impeller |

Public Member Functions | List of all members
impeller::FillPathGeometry Class Referencefinal

A geometry that is created from a filled path object. More...

`#include <fill_path_geometry.h>`

Inheritance diagram for impeller::FillPathGeometry:

## Public Member Functions
| FillPathGeometry (Path path, std::optional< Rect > inner_rect=std::nullopt)
| ~FillPathGeometry ()=default
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
Public Member Functions inherited from impeller::Geometry
virtual bool | IsAxisAlignedRect () const

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::shared_ptr< Geometry > | MakeFillPath (Path path, std::optional< Rect > inner_rect=std::nullopt)
static std::shared_ptr< Geometry > | MakeStrokePath (Path path, Scalar stroke_width=0.0, Scalar miter_limit=4.0, Cap stroke_cap=Cap::kButt, Join stroke_join=Join::kMiter)
static std::shared_ptr< Geometry > | MakeCover ()
static std::shared_ptr< Geometry > | MakeRect (const Rect &rect)
static std::shared_ptr< Geometry > | MakeOval (const Rect &rect)
static std::shared_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, Scalar width, Cap cap)
static std::shared_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::shared_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::shared_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::shared_ptr< Geometry > | MakePointField (std::vector< Point > points, Scalar radius, bool round)
Static Protected Member Functions inherited from impeller::Geometry
static GeometryResult | ComputePositionGeometry (const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)
static GeometryResult | ComputePositionUVGeometry (const Tessellator::VertexGenerator &generator, const Matrix &uv_transform, const Entity &entity, RenderPass &pass)

## Detailed Description

A geometry that is created from a filled path object.

Definition at line 16 of file fill_path_geometry.h.

## Constructor & Destructor Documentation

## ◆ FillPathGeometry()

impeller::FillPathGeometry::FillPathGeometry | ( | Path | path,
|  | std::optional< Rect > | inner_rect = `std::nullopt`
| ) |  |
| explicit

Definition at line 10 of file fill_path_geometry.cc.

11 : path_(std::move(path)), inner_rect_(inner_rect) {}

## ◆ ~FillPathGeometry()

impeller::FillPathGeometry::~FillPathGeometry | ( |  | ) |
| default

## Member Function Documentation

## ◆ CoversArea()

bool impeller::FillPathGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| override virtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Definition at line 145 of file fill_path_geometry.cc.

146 {
147 if (!inner_rect_.has_value()) {
148 return false;
149 }
150 if (!transform.IsTranslationScaleOnly()) {
151 return false;
152 }
153 Rect coverage = inner_rect_->TransformBounds(transform);
154 return coverage.Contains(rect);
155 }

References impeller::TRect< T >::Contains(), impeller::Matrix::IsTranslationScaleOnly(), and impeller::TRect< T >::TransformBounds().

The documentation for this class was generated from the following files:

- impeller/entity/geometry/fill_path_geometry.h
- impeller/entity/geometry/fill_path_geometry.cc

impeller::Rect
TRect< Scalar > Rect
Definition: rect.h:488